package arc.ex;

import arc.ex.ControlModule.CmException;

public class MCD05 extends ControlModule{

	// R}h
	final static byte CLEAR_DATA = (byte)51;
	final static byte EXCHANGE 	= (byte)150;

	class InputData
	{
		int encoder;	// 4 bytes
	};

	class OutputData
	{
		short pwm;		// 2bytes
	}
	
	final static int INPUT_DATA_SIZE  = 4;
	final static int OUTPUT_DATA_SIZE = 2;
		
	InputData inputData;
	OutputData outputData;

	/* Constructor */
	public MCD05()
	{
		name = "MCD05";

		inputData = new InputData();
		outputData = new OutputData();
		
		checkSumEnable = true;
	}

	void clearData() throws CmException
	{
		command = CLEAR_DATA;
		txBuffer.put(command);
		
		transceive( 0, true );
	}

	void exchange( boolean rightNow ) throws CmException
	{
		command = EXCHANGE;
		txBuffer.put(command);
		txBuffer.putShort( outputData.pwm );
		
		transceive( INPUT_DATA_SIZE, rightNow );
	}

	@Override
	void receive( int rxSize ) throws CmException
	{
		super.receive( rxSize );
		
		if( command == EXCHANGE ){
	    	inputData.encoder = rxBuffer.getInt();
		}
	}
	
}